# Configure paths for Devref
# Tim Jansen 2001/03/05
# stolen from Sam Lantinga/SDL
# stolen from Manish Singh
# stolen back from Frank Belew
# stolen from Manish Singh
# Shamelessly stolen from Owen Taylor

dnl AM_PATH_LIBDEVREG([MINIMUM-VERSION, [ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND]]])
dnl Test for libdevreg, and define LIBDEVREG_CFLAGS and LIBDEVREG_LIBS
AC_DEFUN(AM_PATH_LIBDEVREG,
[dnl 
dnl Get the cflags and libraries from the libdevreg-config script
dnl
AC_ARG_WITH(libdevreg-prefix,[  --with-libdevreg-prefix=PFX   Prefix where libdevreg is installed (optional)],
            libdevreg_prefix="$withval", libdevreg_prefix="")
AC_ARG_WITH(libdevreg-exec-prefix,[  --with-libdevreg-exec-prefix=PFX Exec prefix where libdevreg is installed (optional)],
            libdevreg_exec_prefix="$withval", libdevreg_exec_prefix="")
AC_ARG_ENABLE(libdevregtest, [  --disable-libdevregtest       Do not try to compile and run a test libdevreg program],
		    , enable_libdevregtest=yes)

  if test x$libdevreg_exec_prefix != x ; then
     libdevreg_args="$libdevreg_args --exec-prefix=$libdevreg_exec_prefix"
     if test x${LIBDEVREG_CONFIG+set} != xset ; then
        LIBDEVREG_CONFIG=$libdevreg_exec_prefix/bin/libdevreg-config
     fi
  fi
  if test x$libdevreg_prefix != x ; then
     libdevreg_args="$libdevreg_args --prefix=$libdevreg_prefix"
     if test x${LIBDEVREG_CONFIG+set} != xset ; then
        LIBDEVREG_CONFIG=$libdevreg_prefix/bin/libdevreg-config
     fi
  fi

  AC_PATH_PROG(LIBDEVREG_CONFIG, libdevreg-config, no)
  min_libdevreg_version=ifelse([$1], ,0.0.0,$1)
  AC_MSG_CHECKING(for libdevreg - version >= $min_libdevreg_version)
  no_libdevreg=""
  if test "$LIBDEVREG_CONFIG" = "no" ; then
    no_libdevreg=yes
  else
    LIBDEVREG_CFLAGS=`$LIBDEVREG_CONFIG $libdevregconf_args --cflags`
    LIBDEVREG_LIBS=`$LIBDEVREG_CONFIG $libdevregconf_args --libs`

    libdevreg_major_version=`$LIBDEVREG_CONFIG $libdevreg_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\1/'`
    libdevreg_minor_version=`$LIBDEVREG_CONFIG $libdevreg_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\2/'`
    libdevreg_micro_version=`$LIBDEVREG_CONFIG $libdevreg_config_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\3/'`
    if test "x$enable_libdevregtest" = "xyes" ; then
      ac_save_CFLAGS="$CFLAGS"
      ac_save_LIBS="$LIBS"
      CFLAGS="$CFLAGS $LIBDEVREG_CFLAGS"
      LIBS="$LIBS $LIBDEVREG_LIBS"
dnl
dnl Now check if the installed libdevreg is sufficiently new. (Also sanity
dnl checks the results of libdevreg-config to some extent)
dnl
      rm -f conf.libdevregtest
      AC_TRY_RUN([
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libdevreg.h>

int main (int argc, char *argv[])
{
  int major, minor, micro;

  { FILE *fp = fopen("conf.libdevregtest", "a"); if ( fp ) fclose(fp); }

   devreg_set_registry("/proc/devreg");

   if (($libdevreg_major_version > major) ||
      (($libdevreg_major_version == major) && ($libdevreg_minor_version > minor)) ||
      (($libdevreg_major_version == major) && ($libdevreg_minor_version == minor) && ($libdevreg_micro_version >= micro)))
    {
      return 0;
    }
  else
    {
      printf("\n*** 'libdevreg-config --version' returned %d.%d.%d, but the minimum version\n", $libdevreg_major_version, $libdevreg_minor_version, $libdevreg_micro_version);
      printf("*** of libdevreg required is %d.%d.%d. If libdevreg-config is correct, then it is\n", major, minor, micro);
      printf("*** best to upgrade to the required version.\n");
      printf("*** If libdevreg-config was wrong, set the environment variable LIBDEVREG_CONFIG\n");
      printf("*** to point to the correct copy of libdevreg-config, and remove the file\n");
      printf("*** config.cache before re-running configure\n");
      return 1;
    }
}

],, no_libdevreg=yes,[echo $ac_n "cross compiling; assumed OK... $ac_c"])
       CFLAGS="$ac_save_CFLAGS"
       LIBS="$ac_save_LIBS"
     fi
  fi
  if test "x$no_libdevreg" = x ; then
     AC_MSG_RESULT(yes)
     ifelse([$2], , :, [$2])     
  else
     AC_MSG_RESULT(no)
     if test "$LIBDEVREG_CONFIG" = "no" ; then
       echo "*** The libdevreg-config script installed by libdevreg could not be found"
       echo "*** If libdevreg was installed in PREFIX, make sure PREFIX/bin is in"
       echo "*** your path, or set the LIBDEVREG_CONFIG environment variable to the"
       echo "*** full path to libdevreg-config."
     else
       if test -f conf.libdevregtest ; then
        :
       else
          echo "*** Could not run libdevreg test program, checking why..."
          CFLAGS="$CFLAGS $LIBDEVREG_CFLAGS"
          LIBS="$LIBS $LIBDEVREG_LIBS"
          AC_TRY_LINK([
#include <stdio.h>
#include "libdevreg.h"
],      [ return 0; ],
        [ echo "*** The test program compiled, but did not run. This usually means"
          echo "*** that the run-time linker is not finding libmedies or finding the wrong"
          echo "*** version of libdevreg. If it is not finding libdevreg, you'll need to set "
          echo "*** your LD_LIBRARY_PATH environment variable, or edit /etc/ld.so.conf to"
          echo "*** point to the installed location  Also, make sure you have run ldconfig"
          echo "*** if that is required on your system"
	  echo "***"
          echo "*** If you have an old version installed, it is best to remove it, although"
          echo "*** you may also be able to get things to work by modifying LD_LIBRARY_PATH"],
        [ echo "*** The test program failed to compile or link. See the file config.log for the"
          echo "*** exact error that occured. This usually means libdevreg was incorrectly "
	  echo "*** installed or that you have moved libdevreg since it was installed. In the "
	  echo "*** latter case, you may want to edit the libdevreg-config"
	  echo "*** script: $LIBDEVREG_CONFIG" ])
          CFLAGS="$ac_save_CFLAGS"
          LIBS="$ac_save_LIBS"
       fi
     fi
     LIBDEVREG_CFLAGS=""
     LIBDEVREG_LIBS=""
     ifelse([$3], , :, [$3])
  fi

  AC_SUBST(LIBDEVREG_CFLAGS)
  AC_SUBST(LIBDEVREG_LIBS)
  rm -f conf.libdevregtest
])
