/*
 * Defines names for devreg types and device file interfaces
 * bus-specific.
 */

#ifndef LINUX_DEVREG_NAMES_H
#define LINUX_DEVREG_NAMES_H

/* maximum length of a type string, 0 inclusive */
#define DEVREG_TYPE_LEN 64


#define DEVREG_TYPE_UNKNOWN "unknown"

#define DEVREG_TYPE_SOUND "sound/any" /* everything that makes noise or records it */

#define DEVREG_TYPE_INPUT_UNKNOWN   "input/unknown"   /* unknown input device */
#define DEVREG_TYPE_INPUT_KEYBOARD  "input/keyboard" 
#define DEVREG_TYPE_INPUT_POINTER   "input/pointer/any" /* unknown pointing device */
#define DEVREG_TYPE_INPUT_MOUSE     "input/pointer/mouse"  
#define DEVREG_TYPE_INPUT_DIGITIZER "input/pointer/digitizer"  
#define DEVREG_TYPE_INPUT_JOYSTICK  "input/joystick/any"      /* some joystick */
#define DEVREG_TYPE_INPUT_GAMEPAD   "input/joystick/gamepad"  /* gamepad */

#define DEVREG_TYPE_HUB "hub" /* a (usb|firewire...) hub */

#define DEVREG_TYPE_PRINTER "printer" /* printer */




/* maximum length of an interface string, 0 inclusive */
#define DEVREG_INTERFACE_LEN 64

#define DEVREG_INTERFACE_SOUND_OSS      "sound/oss/"

#define DEVREG_INTERFACE_INPUT_EVENTS   "input/event"
#define DEVREG_INTERFACE_INPUT_PS2MOUSE "input/ps2mouse"
#define DEVREG_INTERFACE_INPUT_JOYSTICK "input/joystick"

#define DEVREG_INTERFACE_PRINTER        "printer"


#endif
